dofile( "data/scripts/lib/coroutines.lua" )
dofile( "data/scripts/lib/utilities.lua" )

local player_entity = EntityGetWithTag("player_unit")[1]

local damagemodels = EntityGetComponent( player_entity, "DamageModelComponent" )
local oldVelocity = 0
local damageMultiplier = 2.2

async_loop(function()
	if(EntityGetWithTag("player_unit")[1] ~= nil)then
		if( damagemodels ~= nil) then
			for i,damagemodel in ipairs(damagemodels) do
			
				local hp = tonumber( ComponentGetValue( damagemodel, "hp" ) )
				local max_hp = tonumber( ComponentGetValue( damagemodel, "max_hp" ) )

				local vx, vy = GameGetVelocityCompVelocity(player_entity)
				
				local Velocity = (vx + vy)/2
				
				
				local impactDamage = oldVelocity / damageMultiplier
				
				if(hp > 0)then
					if(Velocity < 0.5 and oldVelocity > 2)then
						if((hp - impactDamage) > 0)then
							ComponentSetValue( damagemodel, "hp", hp - impactDamage)
						else
							ComponentSetValue( damagemodel, "hp", 0.025)
						end
					end
				end
				
				oldVelocity = Velocity

			end
		end
	end
    wait(5)
end)
